; Author  William B. Brogden  9/31/90
;
; For fast determination if a multi word string such as a line of text
; has any words which the "wdRecog" method would recognize 
;
; Assumes that string has words separated by one or more 0s
;  and that the case of characters agrees with the way the
;  recog array was built in the first place. 
; String MUST be 0 terminated for last word to be recognized.
; 
; method will go in the string class,  format will be
; lineRecog(self, aStruct ) where the struct is a recog struct
;  return nil if no word recognized else return int# of word recognized
;
.XLIST
include userprim.inc
.LIST

code    segment word 'CODE'
        assume cs:code
aPrim   proc    near
        pop     bx              ; get receiver OP (string)
        pop     cx              ; OP for struct
        cld      ; set auto increment flag
;  bx = string OP, cx = recog struct OP
       push es   ; preserve
       push dx   ; for return
       push si   ; to calling method
       push di
;
;  reg required for return CS, SS, ES, DX, SI, BP
       mov  dx,cx         ; now use dx for struct OP
       addrOP  bx,si      ; ds:si = string data
       getSize bx,si,cx   ; see ACTOR manual p706 example, cx = string count
       push    cx
       push    ds
       push    si         ; save
       mov     bx,dx      ; xlate struct OP
       addrOP  bx,si      ; ds:si = struct data
       pop     di
       pop     es
       pop     dx         ; es:di = string data dx = count 
       push    si         ; preserve sruct ptr
; - hunt for word start
hw0:   mov  al,es:[di]
       xor  ah,ah
       or   ax,ax
       jnz  hw1         ; a word start
       inc  di
       dec  dx
       jnz  hw0       ; until dx exhausted - ax known 0
       pop  si        ; fix stack
       jmp  exit      ; to return nil
; known to have word start at es:di
hw1:   pop  si
       push si        ; restore si so ds:si -> recog struct start
       jmp  rec1
; 
rec0:  mov al,es:[di]   ; 0 if end of string
       xor ah,ah        ; ensure ah 0
       or  ax,ax
       jnz rec1
; if here, character is null at end of string
       lodsb            ; flag from term cell ds:si  to al
       or  ax,ax        ; if 0 keep looking
       jz  hw0
; at this point we want to return an  int = word# 0 based
       pop    si   ; stack fix
       dec    ax
       asInt  ax   ; convert to Int object
       jmp exit
;   ds:si = struct at start of group of cells
;   es:di = string char  dx = remaining string ct
rec1:  inc si      ; point to ct of cells
       lodsw       ; ct to ax & si points to next cell
       or  ax,ax
       jz  endwd    ; ct 0,  no match, keep trying
       mov  cx,ax  ; count of cells
       mov  al,es:[di] ;  char from string
;
rec2:  cmp  al,[si]  ; ds:si - struct char
       ja   rec3
       jz   rec4
       jmp  endwd    ; no hit possible, seek next word
;
rec3:  inc  si    ; no match at this char but still possible
       inc  si    ; in this set of cells
       inc  si
       loop rec2  ; until cx = 0 - no match possible
       jmp  endwd  ; hunt for end of word
;
rec4:  inc  si       ;  that character matched!
       mov  ax,[si]  ;  offset to ax, 
       add  si,ax    ;  gen new cell pointer
       inc  di       ;  point to next string char
       dec  dx       ;  count down total string
       jnz  rec0
; I don't think we could ever get here, but just in case 
       pop  si
       xor  ax,ax    ; return nil
       jmp  exit
;  we are in a word that does not match, step to end
endwd: xor  ax,ax    ; create nil
       inc  di
       dec  dx    ; string count
       jnz  ew1
       pop  si    ; finished string, fix stack
       jmp  exit
;
ew1:   mov  al,es:[di] ; next char
       or   ax,ax
       jnz  endwd
       jmp  hw0       ; hit nul at end of word 
; ax = either 0 for nil or int
exit:  pop di
       pop si
       pop dx
       pop es 
       exitPrim       ax      ; leave return on stack
aPrim  endp
code   ends
       end
