;  Author:  William B. Brogden    Aug 31, 1990
;
; simple user primitive example from ACTOR manual
;      adapted to recognition algorithm
; method will go in the string class,  format will be
; wdRecog(self, aStruct ) where the struct is generated by recog object
; return nil if not recog, else int word number  0 - n
;
; receiver string MUST be ASCIIZ  - ie null terminated
;   since algorithm does not use string count
;
; - recog struct is in 3 byte cells as follows
;  0  - not used
;  1-2  - count of cells in first level
;  ---- repeat cells for letters this level
;     1 byte - character
;     2 bytes - offset of connected cell
;  -----
;     1 byte - 0 if not a word here, else 1 - 255 word number
;     2 bytes - count of letter cells following
.XLIST
include userprim.inc
.LIST

code    segment word 'CODE'
        assume cs:code
aPrim   proc    near
        pop     bx              ; get receiver OP (string)
        pop     cx              ; OP for struct
        cld       ; auto increment
;  bx = string OP, cx = recog struct OP
        push es   ; preserve
        push dx   ; for return
        push si   ; to calling method
        push di
;  reg required for return CS, SS, ES, DX, SI, BP
        addrOP  bx,si      ; ds:si = string data
        push    ds
        push    si         ; save
        mov     bx,cx      ; recog struct OP
        addrOP  bx,si      ; ds:si = struct data
        pop     di
        pop     es         ; es:di = string data
; we can now use any register except stack ones , I think
rec0:   mov al,es:[di]   ; 0 if empty string
        xor ah,ah        ; ensure ah 0
        or  ax,ax
        jnz rec1
; if here, character is null at end of string
       lodsb            ; flag from term cell ds:si  to al
       or  ax,ax        ; if 0 return nil
       jz  exit
; at this point we want to return an  int = word# 0 based
       dec    ax
       asInt  ax   ; convert to Int object
       jmp exit
;
rec1:  inc si      ; now ds:si points to ct of cells
       lodsw       ; ct to ax & si points to next cell
       or  ax,ax
       jz  exit    ; ct zero,  no match, return nil
       mov  cx,ax  ; count of cells
       mov  al,es:[di] ;  char from string
;
rec2:  cmp  al,[si]  ; ds:si = struct char
       ja   rec3
       jz   rec4
       xor  ax,ax    ; no hit, create nil
       jmp  exit
;
rec3:  inc  si    ; no match at this char but still possible
       inc  si    ; with later one
       inc  si    ; ds:si now -> char of next cell
       loop rec2  ; until cx = 0
       xor  ax,ax ; no match possible, create nil
       jmp  exit
;
rec4:  inc  si       ;  that character matched!
       mov  ax,[si]  ;  offset to ax, 
       add  si,ax    ;  gen new cell pointer
       inc  di       ;  point to next string char
       jmp  rec0
;
exit:  pop di
       pop si
       pop dx
       pop es 
       exitPrim       ax      ; leave return OP on stack
aPrim  endp
code   ends
       end
